<script lang="ts" setup name="DbTypeIndex">
import { ElMessage, ElMessageBox } from 'element-plus'
import DbType from './components/DbType.vue'
import { deleteDbTypeById, getDbTypeByList } from '@/api/database/dbTypeApi'

const state = reactive({
  loading: false,
  // 表格是否自适应高度
  tableAutoHeight: false,
  // 搜索
  search: {
    keywords: '',
  },
  // 列表数据
  dataList: [],
})

const appCatRef = ref()

const getDataList = async () => {
  state.loading = true
  const { data } = await getDbTypeByList({})
  state.dataList = data
  state.loading = false
}

onMounted(() => {
  getDataList()
})

function onDbTypeAdd() {
  appCatRef.value.showAddModel()
}

function onDbTypeEdit(row: any) {
  const appCatId = row.appCatId
  appCatRef.value.showEditModel(appCatId)
}

function onDbTypeDel(row: any) {
  ElMessageBox.confirm(`确认删除「${row.dbTypeTitle}」吗？`, '确认信息').then(async () => {
    await deleteDbTypeById(row.dbTypeId)
    await getDataList()
    ElMessage.success({
      message: '删除成功',
      center: true,
    })
  }).catch(() => {})
}
</script>

<template>
  <div :class="{ 'absolute-container': state.tableAutoHeight }">
    <page-header title="数据库类型设定">
      <template #content>
        <div>
          系统支持多种数据库类型，用于设定接入参数
        </div>
      </template>

      <el-button-group>
        <el-button type="primary" size="large" plain @click="onDbTypeAdd">
          <template #icon>
            <el-icon>
              <svg-icon name="ep:plus" />
            </el-icon>
          </template>
          新增
        </el-button>
      </el-button-group>
    </page-header>

    <page-main>
      <el-table v-loading="state.loading" class="list-table" :data="state.dataList" border stripe highlight-current-row height="100%">
        <el-table-column type="index" label="序号" width="60" header-align="center" align="center" />

        <el-table-column prop="dbTypeTitle" label="名称" header-align="center" align="center" width="200" />

        <el-table-column prop="dbTypeDesc" label="说明" />

        <el-table-column label="操作" width="250" align="center" fixed="right">
          <template #default="scope">
            <el-button type="primary" size="small" plain @click="onDbTypeEdit(scope.row)">
              编辑
            </el-button>
            <el-button v-if="!scope.row.isFixed" type="danger" size="small" plain @click="onDbTypeDel(scope.row)">
              删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </page-main>
    <DbType ref="appCatRef" @success="getDataList" />
  </div>
</template>

<style lang="scss" scoped>
.absolute-container {
  position: absolute;
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;

  .page-header {
    margin-bottom: 0;
  }

  .page-main {
    // 让 page-main 的高度自适应
    flex: 1;
    overflow: auto;
    display: flex;
    flex-direction: column;

    .search-container {
      margin-bottom: 0;
    }
  }
}
</style>
